package app.visionx.apps.csvimportexample.screens;

import com.sibvisions.apps.components.FilterEditor;
import com.sibvisions.apps.components.NavigationTable;
import com.sibvisions.apps.components.web.InsertButton;
import com.sibvisions.apps.components.web.TableMenuButton;
import com.sibvisions.apps.projx.screens.DataSourceWorkScreen;
import com.sibvisions.rad.model.remote.RemoteDataBook;
import java.util.Map;
import javax.rad.application.IWorkScreenApplication;
import javax.rad.genui.IFontAwesome;
import javax.rad.genui.UIDimension;
import javax.rad.genui.UIImage;
import javax.rad.genui.component.UILabel;
import javax.rad.genui.container.UIPanel;
import javax.rad.genui.layout.UIBorderLayout;
import javax.rad.genui.layout.UIFormLayout;
import javax.rad.remote.AbstractConnection;

/**
 * The New screen manages ...
 */
public class CSVImportExampleWorkScreen extends DataSourceWorkScreen
{

	/** insertButton. */
	private InsertButton	insertButton	= new InsertButton();

	/** tableMenuButton. */
	private TableMenuButton	tableMenuButton	= new TableMenuButton();

	/** filterCustomer. */
	private FilterEditor	filterCustomer	= new FilterEditor();

	/** labelSearch. */
	private UILabel			labelSearch		= new UILabel();

	/** tableCustomer. */
	private NavigationTable	tableCustomer	= new NavigationTable();

	/** formLayout1. */
	private UIFormLayout	formLayout1		= new UIFormLayout();

	/** formLayout2. */
	private UIFormLayout	formLayout2		= new UIFormLayout();

	/** panelMain. */
	private UIPanel			panelMain		= new UIPanel();

	/** panel1. */
	private UIPanel			panel1			= new UIPanel();

	/** borderLayout1. */
	private UIBorderLayout	borderLayout1	= new UIBorderLayout();

	/** Remote databook customer. */
	private RemoteDataBook	rdbCustomer		= new RemoteDataBook();

	/**
	 * Constructs a new instance of <code>CSVImportExampleWorkScreen</code>.
	 * 
	 * @param pApplication the application
	 * @param pConnection the connection
	 * @param pParameter additional screen parameters
	 * @throws Throwable if an error occurs
	 */
	public CSVImportExampleWorkScreen(IWorkScreenApplication pApplication, AbstractConnection pConnection, Map<String, Object> pParameter) throws Throwable
	{
		super(pApplication, pConnection, pParameter);

		initializeModel();
		initializeUI();
	}

	/**
	 * Initializes the model.
	 * 
	 * @throws Throwable if the initialization throws an error
	 */
	private void initializeModel() throws Throwable
	{
		rdbCustomer.setName("customer");
		rdbCustomer.setDataSource(getDataSource());
		rdbCustomer.open();

		rdbCustomer.getRowDefinition().getColumnDefinition("ZIP_CODE").setLabel("ZIP Code");

	}

	/**
	 * Initializes the UI.
	 * 
	 * @throws Throwable if the initialization throws an error
	 */
	private void initializeUI() throws Throwable
	{
		tableCustomer.setMaximumSize(new UIDimension(450, 350));
		tableCustomer.setDataBook(rdbCustomer);
		tableCustomer.setAutoResize(false);

		labelSearch.setText("Search");

		filterCustomer.setDataRow(rdbCustomer);

		tableMenuButton.setImage(UIImage.getImage(IFontAwesome.BARS_SMALL));
		tableMenuButton.setDataBook(rdbCustomer);

		insertButton.setText("New");
		insertButton.setImage(UIImage.getImage(UIImage.ADD_SMALL));
		insertButton.setDataBook(rdbCustomer);

		panel1.setLayout(formLayout2);
		panel1.add(labelSearch, formLayout2.getConstraints(0, 0));
		panel1.add(filterCustomer, formLayout2.getConstraints(1, 0, -3, 0));
		panel1.add(tableMenuButton, formLayout2.getVCenterConstraints(-2, 0));
		panel1.add(insertButton, formLayout2.getVCenterConstraints(-1, 0));

		panelMain.setPreferredSize(new UIDimension(451, 128));
		panelMain.setName(".temporary");
		panelMain.setMinimumSize(new UIDimension(0, 0));
		panelMain.setLayout(formLayout1);
		panelMain.add(panel1, formLayout1.getConstraints(0, 0, -1, 0));
		panelMain.add(tableCustomer, formLayout1.getConstraints(0, 1, -1, -1));

		setLayout(borderLayout1);
		add(panelMain, UIBorderLayout.CENTER);
	}

} // CSVImportExampleWorkScreen
